package main

import (
	"electricity_bill_calc/config"
	"electricity_bill_calc/global"
	"fmt"
	"log"

	"github.com/gin-gonic/gin"
)

func init() {
	err := config.SetupSetting()
	if err != nil {
		log.Fatalf("Configuration load failed: %v", err)
	}
	log.Println("Configuration loaded!")

	err = global.SetupDatabaseConnection()
	if err != nil {
		log.Fatalf("Main Database connect failed: %v", err)
	}
	log.Println("Main Database connected!")

	err = global.SetupRedisConnection()
	if err != nil {
		log.Fatalf("Main Cache Database connect failed: %v", err)
	}
	log.Println("Main Cache Database connected!")
}

func main() {
	r := gin.Default()
	r.GET("/ping", func(c *gin.Context) {
		c.JSON(200, gin.H{
			"message": "pong",
		})
	})
	r.Run(fmt.Sprintf(":%d", config.ServerSettings.HttpPort))
}
